/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.kickstone.pricegoblin.data.goblin;

import com.kickstone.pricegoblin.entity.*;
import java.net.URI;
import java.sql.Array;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.ManagedBean;
import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.sql.DataSource;
import javax.xml.bind.annotation.*;
import org.codehaus.jackson.annotate.*;
import org.codehaus.jackson.map.annotate.JsonSerialize;

/**
 *
 * @author john
 */
@JsonWriteNullProperties
@JsonSerialize
@XmlRootElement
@XmlAccessorType(XmlAccessType.NONE)
@JsonAutoDetect({JsonMethod.NONE})
@ManagedBean
public class GoblinData {

    @XmlElement
    @JsonProperty
    public boolean knownRetailer;

    private Integer checkTemplate(String path, List elements, int templateID) throws SQLException {
        Connection c=null;
        Integer offerID=null;
        try {
            c=ds.getConnection();
            int cnt=0;
            // although there should only be one offer, get a list and take the first valid one ordered by id desc
            List<Integer> offerIDs=null;
            offerIDs=em.createNamedQuery("SummaryMap.findOffer")
                               .setParameter(1, templateID)
                               .setParameter(2, "123")
                               .setParameter(3, 2)
                               .getResultList();
            // connection
            elements=new ArrayList();
            Array elementArray=c.createArrayOf("summarymap_element", elements.toArray());
        } finally {
            if (c!=null)
                c.close();
        }
        return offerID;
    }

    // get the product id
    public void getProduct(URI uri){
        String externalUri="http://"+uri.getHost()+"/";
        Retailer retailer=null;
        try {
            retailer=(Retailer)em.createNamedQuery("Retailer.findByExternalUri").setParameter("externalUri", externalUri).getSingleResult();
        } catch (NoResultException ex){
            return;     // TODO - retailer not matched
        }
        try {
            Integer offerID=123456;
            offerID=checkTemplate(null, null, 123);
        } catch (SQLException ex){
            int b=1;
        } catch (NullPointerException ex){
            ex.printStackTrace();
            int a=1;
        }
    }

    @PersistenceContext(unitName="NPETestPU")
    private EntityManager em;

    @Resource(mappedName="jdbc/frontendDB")
    private DataSource ds;
}

